﻿////#define MAX_IT_WORK

using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Windows;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataContext = new Data();
        }

        private void ButtonBase1_OnClick(object sender, RoutedEventArgs e)
        {
            var data = (Data)DataContext;
            data.Max += 1;
        }

        private void ButtonBase2_OnClick(object sender, RoutedEventArgs e)
        {
            var data = (Data)DataContext;
            data.Min = data.Max - 1;
        }
    }

    public class Data : INotifyPropertyChanged
    {
#if MAX_IT_WORK
        private double max = 1;
#else
        private double max;
#endif

        private double min;

        public event PropertyChangedEventHandler PropertyChanged;

        public double Min
        {
            get
            {
                return min;
            }

            set
            {
                SetPropertyAndNotify(ref min, value);
            }
        }

        public double Max
        {
            get
            {
                return max;
            }

            set
            {
                SetPropertyAndNotify(ref max, value);
            }
        }

        private void SetPropertyAndNotify<T>(ref T field, T value, [CallerMemberName] string propertyName = "")
        {
            if (!EqualityComparer<T>.Default.Equals(field, value))
            {
                field = value;
                var handler = this.PropertyChanged;
                if (handler != null)
                {
                    handler(this, new PropertyChangedEventArgs(propertyName));
                }
            }
        }
    }
}
